=== debian/changelog ===
gujin (2.8.7) unstable; urgency=low

  * Release based on Gujin-2.8.7

  * Release based on Gujin-2.8.6

  * Release based on Gujin-2.8.5

  * Release based on Gujin-2.8.4

  * Release based on Gujin-2.8.3

  * Release based on Gujin-2.8.2

  * Release based on Gujin-2.8.1

  * Release based on Gujin-2.8

  * Initial Release based on Gujin-2.7

 -- Etienne Lorrain <etienne.lorrain@gujin.org>  Wed, 9 Jan 2013 19:50:43 +0100
