=== debian/control ===
Source: gujin
Section: admin
Priority: extra
Maintainer: Etienne Lorrain <etienne.lorrain@gujin.org>
Build-Depends: debhelper (>= 7)
Standards-Version: 3.9.3
Homepage: http://gujin.org

Package: gujin
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: graphic boot-loader with mouse for IA32/amd64
 This is a PC boot-loader which, like Lilo and unlike Grub, run completely
 in IA32 real mode (easier to chain-boot other O.S. which expect real-mode
 entry point, or chain-load El-Torito CD/DVDROM, reply natively to unknown
 BIOS interrupts), but like Grub and unlike Lilo, understand file-systems
 and can load kernel/initrd files by their file name, instead of needing to
 be configured with the position/size of the file to load.
 Moreover, unlike any other boot-loader, Gujin is fully graphic (selection
 of the kernel to boot with the mouse), and do not need any configuration
 (but maybe per-distribution /boot/gujin.cmd) because it auto-detects
 BIOS disk order and kernels in the file-systems it understands
 (FAT12/16/32, EXT2/3/4, ISO9660). Standalone/tiny versions are also
 available, they do not display a menu but load the newest kernel found.
 Installing this package will not only install the Gujin installer named
 "gujin", but also install Gujin in the file /boot/gujin.ebios, modifying
 the MBR of the disk.
 If for whatever reason Gujin do not work for you, you can uninstall it
 from the boot-loader itself, and it will restore the previously installed
 boot-loader.
 The installer can be used to initialize and make boot-able floppy disks,
 USB sticks/SD cards, CD/DVD-ROMs, and to query which boot-loader is
 currently installed.
 Removing this package will also replace the MBR with the one saved at
 installation time, so your disk should remain boot-able.
 Note that because Gujin runs natively in real mode, two implementations
 (with and without menu) can be run from DOS, see the man page.
 This package do not need any external libraries, so can be compiled
 indifferently on IA32 hosts or on amd64 hosts.
